Index: /trunk/src/cf_list.c
===================================================================
--- /trunk/src/cf_list.c	(revision 148)
+++ /trunk/src/cf_list.c	(revision 149)
@@ -38,5 +38,5 @@
 	CF_NODE		* front;
 	CF_NODE		* rear;
-} CF_LIST_CTX;
+} CF_LIST_CONTEXT;
 
 /**
@@ -50,9 +50,9 @@
 CF_List_CreateCtx (CF_List_Ctx * ctx)
 {
-	CF_LIST_CTX * context = NULL;
+	CF_LIST_CONTEXT * context = NULL;
 
 	ASSERT_ARGS (ctx == NULL);
 
-	context = (CF_LIST_CTX *) calloc (sizeof (CF_LIST_CTX), 1);
+	context = (CF_LIST_CONTEXT *) calloc (sizeof (CF_LIST_CONTEXT), 1);
 	if (context == NULL)
 		return CF_ERROR_DS_CREATE_CTX;
@@ -73,5 +73,5 @@
 CF_List_DestroyCtx (CF_List_Ctx ctx)
 {
-	CF_LIST_CTX * context = (CF_LIST_CTX *) ctx;
+	CF_LIST_CONTEXT * context = (CF_LIST_CONTEXT *) ctx;
 
 	ASSERT_CTX (ctx);
@@ -96,5 +96,5 @@
 			   CF_Traverser	* traverser)
 {
-	CF_LIST_CTX * context = (CF_LIST_CTX *) ctx;
+	CF_LIST_CONTEXT * context = (CF_LIST_CONTEXT *) ctx;
 
 	ASSERT_CTX (ctx);
@@ -118,5 +118,5 @@
 			  CF_Traverser	* traverser)
 {
-	CF_LIST_CTX * context = (CF_LIST_CTX *) ctx;
+	CF_LIST_CONTEXT * context = (CF_LIST_CONTEXT *) ctx;
 
 	ASSERT_CTX (ctx);
@@ -149,5 +149,5 @@
 				const void			* element)
 {
-	CF_LIST_CTX	* context = (CF_LIST_CTX *) ctx;
+	CF_LIST_CONTEXT	* context = (CF_LIST_CONTEXT *) ctx;
 	CF_NODE		* node = NULL;
 	CF_NODE		* newnode = NULL;
@@ -220,5 +220,5 @@
 				CF_Traverser	* traverser)
 {
-	CF_LIST_CTX	* context = (CF_LIST_CTX *) ctx;
+	CF_LIST_CONTEXT	* context = (CF_LIST_CONTEXT *) ctx;
 	CF_NODE		* node = NULL;
 
@@ -356,5 +356,5 @@
 CF_List_GetSize (CF_List_Ctx ctx)
 {
-	CF_LIST_CTX * context = (CF_LIST_CTX *) ctx;
+	CF_LIST_CONTEXT * context = (CF_LIST_CONTEXT *) ctx;
 
 	ASSERT_CTX (ctx);
Index: /trunk/src/cf_log.c
===================================================================
--- /trunk/src/cf_log.c	(revision 148)
+++ /trunk/src/cf_log.c	(revision 149)
@@ -82,5 +82,5 @@
 	size_t			length; /* data length in current */
 	CF_Mutex_Ctx	mutex;
-} CF_LOG_CTX;
+} CF_LOG_CONTEXT;
 
 typedef struct __cf_log_array__
@@ -182,5 +182,5 @@
 
 static int
-CF_Log_Local_Flush (CF_LOG_CTX * ctx)
+CF_Log_Local_Flush (CF_LOG_CONTEXT * ctx)
 {
 	if (CF_File_Write (ctx->fd, ctx->buffer, ctx->length) < 0)
@@ -204,7 +204,7 @@
  */
 /* static */int
-CF_Log_Local_Push (CF_LOG_CTX	* ctx,
-				   const char	* buffer,
-				   const size_t	demandSize)
+CF_Log_Local_Push (CF_LOG_CONTEXT	* ctx,
+				   const char		* buffer,
+				   const size_t		demandSize)
 {
 	int result = CF_OK;
@@ -250,5 +250,5 @@
 CF_Log_SetMultiThread (CF_Log_Ctx ctx)
 {
-	CF_LOG_CTX * context = (CF_LOG_CTX *) ctx;
+	CF_LOG_CONTEXT * context = (CF_LOG_CONTEXT *) ctx;
 
 	ASSERT_CTX (ctx);
@@ -270,5 +270,5 @@
 CF_Log_UnsetMultiThread (CF_Log_Ctx ctx)
 {
-	CF_LOG_CTX * context = (CF_LOG_CTX *) ctx;
+	CF_LOG_CONTEXT * context = (CF_LOG_CONTEXT *) ctx;
 
 	ASSERT_CTX (ctx);
@@ -299,5 +299,5 @@
 {
 #define BUF_LEN	16 * 1024
-	CF_LOG_CTX	* context = (CF_LOG_CTX *) ctx;
+	CF_LOG_CONTEXT	* context = (CF_LOG_CONTEXT *) ctx;
 	char		buffer[BUF_LEN + 1] = {0x00,};
 	char		datetime[LOG_DATETIME_LENGTH + 1] = {0x00,};
@@ -353,5 +353,5 @@
 CF_Log_FlushCtx (CF_Log_Ctx ctx)
 {
-	CF_LOG_CTX	* context = (CF_LOG_CTX *) ctx;
+	CF_LOG_CONTEXT	* context = (CF_LOG_CONTEXT *) ctx;
 	int			result = 0;
 
@@ -375,5 +375,5 @@
 CF_Log_DestroyCtx (CF_Log_Ctx ctx)
 {
-	CF_LOG_CTX * context = (CF_LOG_CTX *) ctx;
+	CF_LOG_CONTEXT * context = (CF_LOG_CONTEXT *) ctx;
 
 	ASSERT_CTX (ctx);
@@ -417,5 +417,5 @@
 			 : memsize;
 
-	CF_LOG_CTX	* context = NULL;
+	CF_LOG_CONTEXT	* context = NULL;
 
 	if (path == NULL)
@@ -424,5 +424,5 @@
 	TRY
 	{
-		context = (CF_LOG_CTX *) calloc (sizeof (CF_LOG_CTX), 1);
+		context = (CF_LOG_CONTEXT *) calloc (sizeof (CF_LOG_CONTEXT), 1);
 		if (context == NULL)
 		{
Index: /trunk/src/cf_mutex.c
===================================================================
--- /trunk/src/cf_mutex.c	(revision 148)
+++ /trunk/src/cf_mutex.c	(revision 149)
@@ -28,5 +28,5 @@
 {
 	MUTEX_TYPE	mid;
-} CF_MUTEX_CTX;
+} CF_MUTEX_CONTEXT;
 
 /**
@@ -42,7 +42,7 @@
 	int result = 0;
 
-	CF_MUTEX_CTX * context = NULL;
+	CF_MUTEX_CONTEXT * context = NULL;
 
-	context = (CF_MUTEX_CTX *) calloc (sizeof (CF_MUTEX_CTX), 1);
+	context = (CF_MUTEX_CONTEXT *) calloc (sizeof (CF_MUTEX_CONTEXT), 1);
 	if (context == NULL)
 		return CF_ERROR_MUTEX_CREATE_CTX;
@@ -86,5 +86,5 @@
 CF_Mutex_DestoryCtx (CF_Mutex_Ctx ctx)
 {
-	CF_MUTEX_CTX * context = ctx;
+	CF_MUTEX_CONTEXT * context = ctx;
 
 	ASSERT_MUTEX_CTX (ctx);
@@ -114,5 +114,5 @@
 CF_Mutex_Lock (CF_Mutex_Ctx ctx)
 {
-	CF_MUTEX_CTX * context = ctx;
+	CF_MUTEX_CONTEXT * context = ctx;
 
 	ASSERT_MUTEX_CTX (ctx);
@@ -137,5 +137,5 @@
 CF_Mutex_Unlock (CF_Mutex_Ctx ctx)
 {
-	CF_MUTEX_CTX * context = ctx;
+	CF_MUTEX_CONTEXT * context = ctx;
 
 	ASSERT_MUTEX_CTX (ctx);
Index: /trunk/src/cf_thread.c
===================================================================
--- /trunk/src/cf_thread.c	(revision 148)
+++ /trunk/src/cf_thread.c	(revision 149)
@@ -35,5 +35,5 @@
 	THREAD_WORKER	callback;
 	void			* arg;
-} CF_THREAD_CTX;
+} CF_THREAD_CONTEXT;
 
 /**
@@ -51,7 +51,7 @@
 					 void				* arg)
 {
-	CF_THREAD_CTX * context = NULL;
+	CF_THREAD_CONTEXT * context = NULL;
 
-	context = (CF_THREAD_CTX *) calloc (sizeof (CF_THREAD_CTX), 1);
+	context = (CF_THREAD_CONTEXT *) calloc (sizeof (CF_THREAD_CONTEXT), 1);
 	if (context == NULL)
 		return CF_ERROR_THREAD_CREATE_CTX;
@@ -86,5 +86,5 @@
 	int result = 0;
 
-	CF_THREAD_CTX * context = (CF_THREAD_CTX *) ctx;
+	CF_THREAD_CONTEXT * context = (CF_THREAD_CONTEXT *) ctx;
 
 	ASSERT_THREAD_CTX (ctx);
@@ -140,5 +140,5 @@
 CF_Thread_DestroyCtx (CF_Thread_Ctx ctx)
 {
-	CF_THREAD_CTX * context = (CF_THREAD_CTX *) ctx;
+	CF_THREAD_CONTEXT * context = (CF_THREAD_CONTEXT *) ctx;
 
 	ASSERT_THREAD_CTX (ctx);
@@ -165,5 +165,5 @@
 CF_Thread_Join (CF_Thread_Ctx ctx)
 {
-	CF_THREAD_CTX * context = (CF_THREAD_CTX *) ctx;
+	CF_THREAD_CONTEXT * context = (CF_THREAD_CONTEXT *) ctx;
 
 	char status[16] = {0x00,};